'use client';
import { usePathname, useRouter, useSearchParams } from 'next/navigation';
import { useMemo } from 'react';
function NextAdapter(_a) {
    var children = _a.children;
    var router = useRouter();
    var pathname = usePathname();
    var searchParams = useSearchParams();
    var adapter = useMemo(function () {
        function getUrl(location) {
            var url = pathname;
            if (location.search) {
                url += location.search;
            }
            if (window.location.hash) {
                url += window.location.hash;
            }
            return url;
        }
        return {
            replace: function (location) {
                router.replace(getUrl(location));
            },
            push: function (location) {
                router.push(getUrl(location));
            },
            location: {
                search: searchParams.toString()
            }
        };
    }, [searchParams, pathname, router]);
    return children(adapter);
}
export default NextAdapter;
//# sourceMappingURL=NextAdapterApp.js.map