import { useRouter } from 'next/router';
import { useMemo } from 'react';
var pathnameRegex = /[^?#]+/u;
function NextAdapter(_a) {
    var children = _a.children, _b = _a.shallow, shallow = _b === void 0 ? true : _b;
    var router = useRouter();
    var match = router.asPath.match(pathnameRegex);
    var pathname = match ? match[0] : router.asPath;
    var location = useMemo(function () {
        if (typeof window !== 'undefined') {
            // For SSG, no query parameters are available on the server side,
            // since they can't be known at build time. Therefore to avoid
            // markup mismatches, we need a two-part render in this case that
            // patches the client with the updated query parameters lazily.
            // Note that for SSR `router.isReady` will be `true` immediately
            // and therefore there's no two-part render in this case.
            if (router.isReady) {
                return window.location;
            }
            else {
                return { search: '' };
            }
        }
        else {
            // On the server side we only need a subset of the available
            // properties of `Location`. The other ones are only necessary
            // for interactive features on the client.
            return { search: router.asPath.replace(pathnameRegex, '') };
        }
    }, [router.asPath, router.isReady]);
    var adapter = useMemo(function () {
        function createUpdater(routeFn) {
            return function updater(_a) {
                var hash = _a.hash, search = _a.search;
                routeFn({ pathname: router.pathname, search: search, hash: hash }, { pathname: pathname, search: search, hash: hash }, { shallow: shallow, scroll: false });
            };
        }
        return {
            push: createUpdater(router.push),
            replace: createUpdater(router.replace),
            location: location
        };
    }, [location, pathname, router, shallow]);
    return children(adapter);
}
export default NextAdapter;
//# sourceMappingURL=NextAdapterPages.js.map